#include"file.h"

file::file(const std::string& file_name1): 
    file_name(file_name1) 
{}

void file::addData() 
{
    std::ofstream File(file_name, std::ios::binary);
    if (!File.is_open()) 
    {
        std::cerr << "Error, file cant be opened" << std::endl;
        exit(EXIT_FAILURE);
    }
    bool flag = 1;
    Bank new_bank;
    std::cout << "Enter the bank accounts data:" << std::endl;
    while (flag) 
    {
        std::cout << "Enter clients surname, date of opening the account, account number, account id, the total deposit (sum) and annual percentage:" << std::endl;
        std::cin >> new_bank;
        File.write(reinterpret_cast<const char*>(&new_bank), sizeof(Bank));
        std::cout << "press 0 to exit or 1 to continue adding new data:" << std::endl;
        std::cin >> flag;
    }
}

void file::makeMap(std::map<int, Bank>& map1) 
{
    Bank new_bank;
    std::ifstream file(file_name, std::ios::binary);
    int id = 0;
    while (file.read(reinterpret_cast<char*>(&new_bank), sizeof(Bank))) 
    {
        map1.insert(std::make_pair(id, new_bank));
        ++id;
    }
}

void file::deleteData(int id) 
{
    std::map<int, Bank> map;
    makeMap(map);
    map.erase(id);
    std::ofstream File(file_name, std::ios::binary);
    if (!File.is_open()) 
    {
        std::cerr << "Error, file cant be opened" << std::endl;
        exit(EXIT_FAILURE);
    }
    for (const auto& new_bank : map) 
    {
        File.write(reinterpret_cast<const char*>(&new_bank.second), sizeof(Bank));
    }
}

void file::replaceData(int id, const Bank& new_bank) 
{
    std::map<int, Bank> map;
    makeMap(map);
    std::ofstream File(file_name, std::ios::binary);
    if (!File.is_open()) 
    {
        std::cerr << "Error, file cant be opened" << std::endl;
        exit(EXIT_FAILURE);
    }
    map[id] = new_bank;
    for (const auto& new_bank : map) 
    {
        File.write(reinterpret_cast<const char*>(&new_bank.second), sizeof(Bank));
    }
}

void file::toText() 
{
    std::map<int, Bank> map;
    makeMap(map);
    std::string new_file_name = file_name + " .txt";
    std::ofstream File(new_file_name);
    if (!File.is_open()) 
    {
        std::cerr << "Error, file cant be opened" << std::endl;
        exit(EXIT_FAILURE);
    }

    File << "----Bank accounts details----" << std::endl;
    
    //!!! Шапка должна формироваться программно манипуляторами, а не пробелами.
    
    File << "| ### | CLIENTS SURNAME | DATE | ACCOUNT NUMBER | ACCOUNT ID | SUM | ANNUAL PERCENT |" << std::endl;
    size_t n = 0;
    for (const auto& element : map) 
    {
        
        File << "|" << std::setw(3) << n << "|"
            << std::setw(12) << element.second.clients_surname << "|"
            << std::setw(12) << element.second.date << "|"
            << std::setw(12) << element.second.account_number << "|"
            << std::setw(12) << element.second.account_id << "|"
            << std::setw(12) << element.second.sum << "|"
            << std::setw(12) << element.second.annual_percent << "|"
            << std::endl;
        n++;
    }
}

void file::searchBySurname(const std::string& surname1) 
{
    std::map<int, Bank> map;
    makeMap(map);
    std::vector<Bank> result;
    for (const auto& new_bank : map) 
    {
        if (new_bank.second.clients_surname == surname1) 
        {
            std::cout << "Found such surname!" << std::endl;
            result.push_back(new_bank.second);
        }
    }
    std::ofstream F("result1.bin", std::ios::binary);
    for (const auto& new_bank : result) 
    {
        F.write(reinterpret_cast<const char*>(&new_bank), sizeof(Bank));
    }
}

void file::searchByAccNum(int acc_num) 
{
    std::map<int, Bank> map;
    makeMap(map);
    std::vector<Bank> result;

    for (const auto& new_bank : map) 
    {
        if (new_bank.second.account_number == acc_num) 
        {
            std::cout << "Found such Account number!" << std::endl;
            result.push_back(new_bank.second);
        }
    }
    std::ofstream F("result2.bin", std::ios::binary);
    for (const auto& new_bank : result)
    {
        F.write(reinterpret_cast<const char*>(&new_bank), sizeof(Bank));
    }
}

void file::searchByAccId(int acc_id) 
{
    std::map<int, Bank> map;
    makeMap(map);
    std::vector<Bank> result;

    for (const auto& new_bank : map)
    {
        std::cout << "Found such Account Id!" << std::endl;
        if (new_bank.second.account_id == acc_id)
        {
            result.push_back(new_bank.second);
        }
    }
    std::ofstream F("result3.bin", std::ios::binary);
    for (const auto& new_bank : result)
    {
        F.write(reinterpret_cast<const char*>(&new_bank), sizeof(Bank));
    }
}